/*******************************************************************************
 * Copyright (C) 2009 - Ikaro Games   www.ikarogames.com                       *
 *                                                                             *
 * This program is free software; you can redistribute it and/or               *
 * modify it under the terms of the GNU General Public License                 *
 * as published by the Free Software Foundation; either version 2              *
 * of the License, or (at your option) any later version.                      *
 *                                                                             *
 * This program is distributed in the hope that it will be useful,             *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with this program; if not, write to the Free Software                 *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
 *                                                                             *
 *                                                                             *
 ******************************************************************************/

#ifndef CSCREENSCONFIGELEMENT_H_
#define CSCREENSCONFIGELEMENT_H_

#include <vector>

// forward declaration
class CScreenElement;

class CScreensConfigElement {
public:
	CScreensConfigElement();
	CScreensConfigElement(const CScreensConfigElement &screensConfig);
	virtual ~CScreensConfigElement();

	void addScreen(const CScreenElement &screen);
	const std::vector<CScreenElement>& getScreens() const;

	CScreensConfigElement& operator=(const CScreensConfigElement &screensConfig);

private:
	std::vector<CScreenElement>	m_screens;
};

#endif /* CSCREENSCONFIGELEMENT_H_ */
