/******************************************************************************
* Copyright (C) 2009 - Ikaro Games   www.ikarogames.com                       *
*                                                                             *
* This program is free software; you can redistribute it and/or               *
* modify it under the terms of the GNU General Public License                 *
* as published by the Free Software Foundation; either version 2              *
* of the License, or (at your option) any later version.                      *
*                                                                             *
* This program is distributed in the hope that it will be useful,             *
* but WITHOUT ANY WARRANTY; without even the implied warranty of              *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
* GNU General Public License for more details.                                *
*                                                                             *
* You should have received a copy of the GNU General Public License           *
* along with this program; if not, write to the Free Software                 *
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                             *
*                                                                             *
*       generated by dia/DAOcodegen.py                                        *
*       Version: 1.21                                                         *
******************************************************************************/

#include <iostream>
#include <sstream>

#include "CPfCompetitionsBySeasonDAOSQLite.h"

CPfCompetitionsBySeasonDAOSQLite::CPfCompetitionsBySeasonDAOSQLite(sqlite3 *database)
  : CPfCompetitionsBySeasonDAOSQLiteEntity(database)
{
}

CPfCompetitionsBySeasonDAOSQLite::~CPfCompetitionsBySeasonDAOSQLite()
{
}

std::vector<CPfCompetitionsBySeason*>* CPfCompetitionsBySeasonDAOSQLite::findByXFkSeason(int XFkSeason)
{
    std::ostringstream stream;
    stream << XFkSeason;
    return findByXFkSeason(stream.str());
}

std::vector<CPfCompetitionsBySeason*>* CPfCompetitionsBySeasonDAOSQLite::findByXFkSeason(const std::string &XFkSeason)
{
    std::string sql(
    		"SELECT * "
    		"FROM PF_COMPETITIONS_BY_SEASON ");
    sql +=  "WHERE X_FK_SEASON='"+XFkSeason+"'";
    return loadVector(sql);
}

CPfCompetitionsBySeason* CPfCompetitionsBySeasonDAOSQLite::findByXCompetitionBySeason(int XCompetitionBySeason)
{
    std::ostringstream stream;
    stream << XCompetitionBySeason;
    return findByXCompetitionBySeason(stream.str());
}

CPfCompetitionsBySeason* CPfCompetitionsBySeasonDAOSQLite::findByXCompetitionBySeason(const std::string &XCompetitionBySeason)
{
    std::string sql(
    		"SELECT * "
    		"FROM PF_COMPETITIONS_BY_SEASON ");
    sql +=  "WHERE X_COMPETITION_BY_SEASON='"+XCompetitionBySeason+"'";
    return loadRegister(sql);
}

std::vector<CPfCompetitionsBySeason*>* CPfCompetitionsBySeasonDAOSQLite::findByXFkCompetition(int XFkCompetition)
{
    std::ostringstream stream;
    stream << XFkCompetition;
    return findByXFkCompetition(stream.str());
}

std::vector<CPfCompetitionsBySeason*>* CPfCompetitionsBySeasonDAOSQLite::findByXFkCompetition(const std::string &XFkCompetition)
{
    std::string sql(
    		"SELECT * FROM PF_COMPETITIONS_BY_SEASON ");
    sql +=  "WHERE X_FK_COMPETITION='"+XFkCompetition+"'";
    return loadVector(sql);
}

CPfCompetitionsBySeason* CPfCompetitionsBySeasonDAOSQLite::findByXFkSeasonAndXTeam(int XFkSeason, int XTeam)
{
    std::ostringstream stream;
    stream << XFkSeason;
    std::ostringstream stream2;
    stream2 << XTeam;
    return findByXFkSeasonAndXTeam(stream.str(), stream2.str());
}

CPfCompetitionsBySeason* CPfCompetitionsBySeasonDAOSQLite::findByXFkSeasonAndXTeam(const std::string &XFkSeason, const std::string &XTeam)
{
    std::string sql(
            "SELECT CS.* "
            "FROM PF_COMPETITIONS_BY_SEASON CS "
            "JOIN PF_TEAMS_BY_COMPETITIONS TC ON TC.X_FK_COMPETITION_BY_SEASON = CS.X_COMPETITION_BY_SEASON ");
    sql +=  "WHERE X_FK_SEASON='"+ XFkSeason +"' "
            "AND TC.X_FK_TEAM='" + XTeam + "'";
    return loadRegister(sql);
}
