/******************************************************************************
* Copyright (C) 2008 - Ikaro Games   www.ikarogames.com                       *
*                                                                             *
* This program is free software; you can redistribute it and/or               *
* modify it under the terms of the GNU General Public License                 *
* as published by the Free Software Foundation; either version 2              *
* of the License, or (at your option) any later version.                      *
*                                                                             *
* This program is distributed in the hope that it will be useful,             *
* but WITHOUT ANY WARRANTY; without even the implied warranty of              *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
* GNU General Public License for more details.                                *
*                                                                             *
* You should have received a copy of the GNU General Public License           *
* along with this program; if not, write to the Free Software                 *
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                             *
*                                                                             *
*       generated by dia/DAOcodegen.py                                        *
*       Version: 1.20                                                         *
******************************************************************************/

#include <iostream>
#include <sstream>

#include "CPfConfederationsDAOSQLite.h"

CPfConfederationsDAOSQLite::CPfConfederationsDAOSQLite(sqlite3 *database)
  : CPfConfederationsDAOSQLiteEntity(database)
{
}

CPfConfederationsDAOSQLite::~CPfConfederationsDAOSQLite()
{
}

CPfConfederations* CPfConfederationsDAOSQLite::findByXConfederation(int XConfederation)
{
    std::ostringstream stream;
    stream << XConfederation;
    return findByXConfederation(stream.str());
}

CPfConfederations* CPfConfederationsDAOSQLite::findByXConfederation(const std::string &XConfederation)
{
    std::string sql(
    		"SELECT * "
    		"FROM PF_CONFEDERATIONS ");
    sql +=  "WHERE X_CONFEDERATION='"+XConfederation+"'";
    return loadRegister(sql);
}

std::vector<CPfConfederations*>* CPfConfederationsDAOSQLite::findAll()
{
    return loadVector("SELECT * FROM PF_CONFEDERATIONS");
}

std::vector<CPfConfederations*>* CPfConfederationsDAOSQLite::findByXFKSeasonWithLeague(int XFKSeason)
{
    std::ostringstream stream;
    stream << XFKSeason;
    return findByXFKSeasonWithLeague(stream.str());
}

std::vector<CPfConfederations*>* CPfConfederationsDAOSQLite::findByXFKSeasonWithLeague(const std::string &XFKSeason)
{
	std::string sql(
			"SELECT DISTINCT CF.* "
			"FROM PF_CONFEDERATIONS CF "
			"  JOIN PF_COUNTRIES CU ON CU.X_FK_CONFEDERATION=CF.X_CONFEDERATION "
			"  JOIN PF_COMPETITIONS CO ON CO.X_FK_COUNTRY=CU.X_COUNTRY "
			"  JOIN PF_COMPETITIONS_BY_SEASON CBS ON CBS.X_FK_COMPETITION=CO.X_COMPETITION ");
	sql +=  "WHERE CBS.X_FK_SEASON='"+XFKSeason+"'";
	return loadVector(sql);
}
