/******************************************************************************
* Copyright (C) 2009 - Ikaro Games   www.ikarogames.com                       *
*                                                                             *
* This program is free software; you can redistribute it and/or               *
* modify it under the terms of the GNU General Public License                 *
* as published by the Free Software Foundation; either version 2              *
* of the License, or (at your option) any later version.                      *
*                                                                             *
* This program is distributed in the hope that it will be useful,             *
* but WITHOUT ANY WARRANTY; without even the implied warranty of              *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
* GNU General Public License for more details.                                *
*                                                                             *
* You should have received a copy of the GNU General Public License           *
* along with this program; if not, write to the Free Software                 *
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                             *
*                                                                             *
*       generated by dia/DAOcodegen.py                                        *
*       Version: 1.23                                                         *
******************************************************************************/

#include <stdlib.h>
#include <string.h>

#include "CPfFormationsByCoachesDAOSQLiteEntity.h"
#include "../../../../../exceptions/PFException.h"
#include "../../../../../utils/CLog.h"

CPfFormationsByCoachesDAOSQLiteEntity::CPfFormationsByCoachesDAOSQLiteEntity(sqlite3 *database)
{
    m_database = database;
}

CPfFormationsByCoachesDAOSQLiteEntity::~CPfFormationsByCoachesDAOSQLiteEntity()
{
}

void CPfFormationsByCoachesDAOSQLiteEntity::setSQLite(sqlite3 *database)
{
    m_database = database;
}

bool CPfFormationsByCoachesDAOSQLiteEntity::deleteReg(CPfFormationsByCoaches *reg)
{
    std::string sql("DELETE FROM PF_FORMATIONS_BY_COACHES WHERE X_FORMATION_BY_COACH=");
    sql += "'"+reg->getXFormationByCoach_str()+"'";
    return exec(sql);
}

bool CPfFormationsByCoachesDAOSQLiteEntity::insertReg(CPfFormationsByCoaches *reg)
{
    std::string sql("INSERT INTO PF_FORMATIONS_BY_COACHES (X_FK_FORMATION,N_SKILL,X_FK_COACH) VALUES (");
    sql += (reg->getXFkFormation_str()=="")?"NULL":"'"+reg->getXFkFormation_str()+"'";
    sql += (reg->getNSkill_str()=="")?",NULL":",'"+reg->getNSkill_str()+"'";
    sql += (reg->getXFkCoach_str()=="")?",NULL":",'"+reg->getXFkCoach_str()+"'";
    sql += ")";
    if( exec(sql) ){
        reg->setXFormationByCoach(sqlite3_last_insert_rowid(m_database));
        return true;
    }else{
        return false;
    }
}

bool CPfFormationsByCoachesDAOSQLiteEntity::updateReg(CPfFormationsByCoaches *reg)
{
    std::string sql("UPDATE PF_FORMATIONS_BY_COACHES SET ");
    sql += (reg->getXFkFormation_str()=="")?" X_FK_FORMATION=NULL":" X_FK_FORMATION='"+reg->getXFkFormation_str()+"'";
    sql += (reg->getNSkill_str()=="")?",N_SKILL=NULL":",N_SKILL='"+reg->getNSkill_str()+"'";
    sql += (reg->getXFkCoach_str()=="")?",X_FK_COACH=NULL":",X_FK_COACH='"+reg->getXFkCoach_str()+"'";
    sql += (reg->getXFormationByCoach_str()=="")?",X_FORMATION_BY_COACH=NULL":",X_FORMATION_BY_COACH='"+reg->getXFormationByCoach_str()+"'";
    sql += " WHERE X_FORMATION_BY_COACH='"+reg->getXFormationByCoach_str()+"'";
    return exec(sql);
}

void CPfFormationsByCoachesDAOSQLiteEntity::freeVector(std::vector<CPfFormationsByCoaches*>* vector )
{
    std::vector<CPfFormationsByCoaches*>::iterator it;
    for( it=vector->begin(); it!=vector->end(); it++ ){
        delete (*it);
        (*it) = NULL;
    }
    delete vector;
}

CPfFormationsByCoaches* CPfFormationsByCoachesDAOSQLiteEntity::loadRegister(const std::string &sql)
{
    if( m_database==NULL ){
        throw PFEXCEPTION("No database connection.");
    }

    char *msgError = NULL;
    CPfFormationsByCoaches *destiny = new CPfFormationsByCoaches();
    int result = sqlite3_exec(m_database, sql.c_str(), callbackRegister, destiny, &msgError);
    if( result!=SQLITE_OK && result!=SQLITE_ABORT ){
        LOG_ERROR("Error in SQL: \"%s\" --> \"%s\"", sql.c_str(), msgError);
    }
    if( msgError!=NULL ){ 
        sqlite3_free(msgError);
    }
    return destiny;
}

std::vector<CPfFormationsByCoaches*> * CPfFormationsByCoachesDAOSQLiteEntity::loadVector(const std::string &sql)
{
    if( m_database==NULL ){
        throw PFEXCEPTION("No database connection.");
    }

    char *msgError = NULL;
    std::vector<CPfFormationsByCoaches*> *container = new std::vector<CPfFormationsByCoaches*>;
    int result = sqlite3_exec(m_database, sql.c_str(), callbackVector, container, &msgError);
    if( result!=SQLITE_OK ){
        LOG_ERROR("Error in SQL: \"%s\" --> \"%s\"", sql.c_str(), msgError);
    }
    if( msgError!=NULL ){ 
        sqlite3_free(msgError);
    }
    return container;
}

bool CPfFormationsByCoachesDAOSQLiteEntity::exec(const std::string &sql)
{
    if( m_database==NULL ){
        throw PFEXCEPTION("No database connection.");
    }

    char *msgError = NULL;
    bool correct = true;
    int result = sqlite3_exec(m_database, sql.c_str(), NULL, NULL, &msgError);
    if( result!=SQLITE_OK ){
        LOG_ERROR("Error in SQL: \"%s\" --> \"%s\"", sql.c_str(), msgError);
        correct = false;
    }
    if( msgError!=NULL ){ 
        sqlite3_free(msgError);
    }
    return correct;
}

int CPfFormationsByCoachesDAOSQLiteEntity::callbackRegister(void *object, int nColumns, char **vColumn, char **sColumn)
{
    if( object!=NULL ){
        CPfFormationsByCoaches *destiny = (CPfFormationsByCoaches*)object;
        for( int i=0; i<nColumns; i++ ){
            if( strcmp(sColumn[i], "X_FK_FORMATION")==0 ){
                destiny->setXFkFormation_str((vColumn[i]==NULL)?"":vColumn[i]);
            }else if( strcmp(sColumn[i], "N_SKILL")==0 ){
                destiny->setNSkill_str((vColumn[i]==NULL)?"":vColumn[i]);
            }else if( strcmp(sColumn[i], "X_FK_COACH")==0 ){
                destiny->setXFkCoach_str((vColumn[i]==NULL)?"":vColumn[i]);
            }else if( strcmp(sColumn[i], "X_FORMATION_BY_COACH")==0 ){
                destiny->setXFormationByCoach_str((vColumn[i]==NULL)?"":vColumn[i]);
            }
        }
    }
    return -1; // Abort, don't load more rows
}

int CPfFormationsByCoachesDAOSQLiteEntity::callbackVector(void *object, int nColumns, char **vColumn, char **sColumn)
{
    if( object!=NULL ){
        std::vector<CPfFormationsByCoaches*> *container = (std::vector<CPfFormationsByCoaches*> *)object;
        CPfFormationsByCoaches *destiny = new CPfFormationsByCoaches();
        for( int i=0; i<nColumns; i++ ){
            if( strcmp(sColumn[i], "X_FK_FORMATION")==0 ){
                destiny->setXFkFormation_str((vColumn[i]==NULL)?"":vColumn[i]);
            }else if( strcmp(sColumn[i], "N_SKILL")==0 ){
                destiny->setNSkill_str((vColumn[i]==NULL)?"":vColumn[i]);
            }else if( strcmp(sColumn[i], "X_FK_COACH")==0 ){
                destiny->setXFkCoach_str((vColumn[i]==NULL)?"":vColumn[i]);
            }else if( strcmp(sColumn[i], "X_FORMATION_BY_COACH")==0 ){
                destiny->setXFormationByCoach_str((vColumn[i]==NULL)?"":vColumn[i]);
            }
        }
        container->push_back(destiny);
    }
    return 0; // All OK
}

