/******************************************************************************
* Copyright (C) 2010 - Ikaro Games   www.ikarogames.com                       *
*                                                                             *
* This program is free software; you can redistribute it and/or               *
* modify it under the terms of the GNU General Public License                 *
* as published by the Free Software Foundation; either version 2              *
* of the License, or (at your option) any later version.                      *
*                                                                             *
* This program is distributed in the hope that it will be useful,             *
* but WITHOUT ANY WARRANTY; without even the implied warranty of              *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
* GNU General Public License for more details.                                *
*                                                                             *
* You should have received a copy of the GNU General Public License           *
* along with this program; if not, write to the Free Software                 *
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                             *
*                                                                             *
*       generated by dia/DAOcodegen.py                                        *
*       Version: 1.23                                                         *
******************************************************************************/

#ifndef CDAOFACTORYSQLITE_H_
#define CDAOFACTORYSQLITE_H_

#include <sqlite3.h>
#include <string>

#include "../../../dao/factory/IDAOFactory.h"

#include "../../../dao/IPfCompetitionPhasesDAO.h"
#include "../../../dao/IPfRankingDAO.h"
#include "../../../dao/IPfTeamAveragesDAO.h"
#include "../../../dao/IPfFormationsDAO.h"
#include "../../../dao/IPfTeamsByCompetitionsDAO.h"
#include "../../../dao/IPfConfederationsDAO.h"
#include "../../../dao/IPfTeamPlayersDAO.h"
#include "../../../dao/IPfStadiumsDAO.h"
#include "../../../dao/IPfTeamsDAO.h"
#include "../../../dao/IPfTeamPlayerAveragesDAO.h"
#include "../../../dao/IPfCompetitionsBySeasonDAO.h"
#include "../../../dao/IPfSeasonsDAO.h"
#include "../../../dao/IPfDemarcationsDAO.h"
#include "../../../dao/IPfTeamPlayerContractsDAO.h"
#include "../../../dao/IPfStrategicPositionsDAO.h"
#include "../../../dao/IPfCoachesDAO.h"
#include "../../../dao/IPfMatchesDAO.h"
#include "../../../dao/IPfGameOptionsDAO.h"
#include "../../../dao/IPfGoalsDAO.h"
#include "../../../dao/IPfRolesDAO.h"
#include "../../../dao/IPfCountriesDAO.h"
#include "../../../dao/IPfCoachContractsDAO.h"
#include "../../../dao/IPfRolesByTeamPlayersDAO.h"
#include "../../../dao/IPfFormationsByCoachesDAO.h"
#include "../../../dao/IPfScorersDAO.h"
#include "../../../dao/IPfCompetitionsDAO.h"

#include "../CPfCompetitionPhasesDAOSQLite.h"
#include "../CPfRankingDAOSQLite.h"
#include "../CPfTeamAveragesDAOSQLite.h"
#include "../CPfFormationsDAOSQLite.h"
#include "../CPfTeamsByCompetitionsDAOSQLite.h"
#include "../CPfConfederationsDAOSQLite.h"
#include "../CPfTeamPlayersDAOSQLite.h"
#include "../CPfStadiumsDAOSQLite.h"
#include "../CPfTeamsDAOSQLite.h"
#include "../CPfTeamPlayerAveragesDAOSQLite.h"
#include "../CPfCompetitionsBySeasonDAOSQLite.h"
#include "../CPfSeasonsDAOSQLite.h"
#include "../CPfDemarcationsDAOSQLite.h"
#include "../CPfTeamPlayerContractsDAOSQLite.h"
#include "../CPfStrategicPositionsDAOSQLite.h"
#include "../CPfCoachesDAOSQLite.h"
#include "../CPfMatchesDAOSQLite.h"
#include "../CPfGameOptionsDAOSQLite.h"
#include "../CPfGoalsDAOSQLite.h"
#include "../CPfRolesDAOSQLite.h"
#include "../CPfCountriesDAOSQLite.h"
#include "../CPfCoachContractsDAOSQLite.h"
#include "../CPfRolesByTeamPlayersDAOSQLite.h"
#include "../CPfFormationsByCoachesDAOSQLite.h"
#include "../CPfScorersDAOSQLite.h"
#include "../CPfCompetitionsDAOSQLite.h"

class CDAOFactorySQLite : public IDAOFactory
{
public:
    CDAOFactorySQLite(const std::string &filepath);
    virtual ~CDAOFactorySQLite();

    virtual bool executeScript(const std::string &script);
    virtual bool executeScriptFile(const char *scriptFile);

    virtual bool beginTransaction();
    virtual bool commit();
    virtual bool rollback();

    virtual void save();

    virtual IPfCompetitionPhasesDAO* getIPfCompetitionPhasesDAO();
    virtual IPfRankingDAO* getIPfRankingDAO();
    virtual IPfTeamAveragesDAO* getIPfTeamAveragesDAO();
    virtual IPfFormationsDAO* getIPfFormationsDAO();
    virtual IPfTeamsByCompetitionsDAO* getIPfTeamsByCompetitionsDAO();
    virtual IPfConfederationsDAO* getIPfConfederationsDAO();
    virtual IPfTeamPlayersDAO* getIPfTeamPlayersDAO();
    virtual IPfStadiumsDAO* getIPfStadiumsDAO();
    virtual IPfTeamsDAO* getIPfTeamsDAO();
    virtual IPfTeamPlayerAveragesDAO* getIPfTeamPlayerAveragesDAO();
    virtual IPfCompetitionsBySeasonDAO* getIPfCompetitionsBySeasonDAO();
    virtual IPfSeasonsDAO* getIPfSeasonsDAO();
    virtual IPfDemarcationsDAO* getIPfDemarcationsDAO();
    virtual IPfTeamPlayerContractsDAO* getIPfTeamPlayerContractsDAO();
    virtual IPfStrategicPositionsDAO* getIPfStrategicPositionsDAO();
    virtual IPfCoachesDAO* getIPfCoachesDAO();
    virtual IPfMatchesDAO* getIPfMatchesDAO();
    virtual IPfGameOptionsDAO* getIPfGameOptionsDAO();
    virtual IPfGoalsDAO* getIPfGoalsDAO();
    virtual IPfRolesDAO* getIPfRolesDAO();
    virtual IPfCountriesDAO* getIPfCountriesDAO();
    virtual IPfCoachContractsDAO* getIPfCoachContractsDAO();
    virtual IPfRolesByTeamPlayersDAO* getIPfRolesByTeamPlayersDAO();
    virtual IPfFormationsByCoachesDAO* getIPfFormationsByCoachesDAO();
    virtual IPfScorersDAO* getIPfScorersDAO();
    virtual IPfCompetitionsDAO* getIPfCompetitionsDAO();


private:
    void copyFile(const std::string &origin, const std::string &destination);

private:
    sqlite3     *m_database;
    std::string m_filepath;
    std::string m_filepath_tmp;

    CPfCompetitionPhasesDAOSQLite *m_PfCompetitionPhasesDAOSQLite;
    CPfRankingDAOSQLite *m_PfRankingDAOSQLite;
    CPfTeamAveragesDAOSQLite *m_PfTeamAveragesDAOSQLite;
    CPfFormationsDAOSQLite *m_PfFormationsDAOSQLite;
    CPfTeamsByCompetitionsDAOSQLite *m_PfTeamsByCompetitionsDAOSQLite;
    CPfConfederationsDAOSQLite *m_PfConfederationsDAOSQLite;
    CPfTeamPlayersDAOSQLite *m_PfTeamPlayersDAOSQLite;
    CPfStadiumsDAOSQLite *m_PfStadiumsDAOSQLite;
    CPfTeamsDAOSQLite *m_PfTeamsDAOSQLite;
    CPfTeamPlayerAveragesDAOSQLite *m_PfTeamPlayerAveragesDAOSQLite;
    CPfCompetitionsBySeasonDAOSQLite *m_PfCompetitionsBySeasonDAOSQLite;
    CPfSeasonsDAOSQLite *m_PfSeasonsDAOSQLite;
    CPfDemarcationsDAOSQLite *m_PfDemarcationsDAOSQLite;
    CPfTeamPlayerContractsDAOSQLite *m_PfTeamPlayerContractsDAOSQLite;
    CPfStrategicPositionsDAOSQLite *m_PfStrategicPositionsDAOSQLite;
    CPfCoachesDAOSQLite *m_PfCoachesDAOSQLite;
    CPfMatchesDAOSQLite *m_PfMatchesDAOSQLite;
    CPfGameOptionsDAOSQLite *m_PfGameOptionsDAOSQLite;
    CPfGoalsDAOSQLite *m_PfGoalsDAOSQLite;
    CPfRolesDAOSQLite *m_PfRolesDAOSQLite;
    CPfCountriesDAOSQLite *m_PfCountriesDAOSQLite;
    CPfCoachContractsDAOSQLite *m_PfCoachContractsDAOSQLite;
    CPfRolesByTeamPlayersDAOSQLite *m_PfRolesByTeamPlayersDAOSQLite;
    CPfFormationsByCoachesDAOSQLite *m_PfFormationsByCoachesDAOSQLite;
    CPfScorersDAOSQLite *m_PfScorersDAOSQLite;
    CPfCompetitionsDAOSQLite *m_PfCompetitionsDAOSQLite;

};
#endif /*CDAOFACTORYSQLITE_H_*/
